#!/bin/bash

case "$1" in
install)
  systemctl stop vsound
  modprobe -r vsound
  modprobe -r netmap

  systemctl stop pipe
  systemctl disable pipe.service
  modprobe -r rtalsa

  echo "*Copy Modules*"
  cp -v ./aoe /usr/bin
  cp -v ./netmap.ko /lib/modules/4.19.86-v8/kernel/drivers/xenomai/smpd/
  cp -v ./vsound.ko /lib/modules/4.19.86-v8/kernel/drivers/xenomai/smpd/
  cp -v ./modules.conf /etc/modules-load.d/modules.conf
  if [ ! -f /lib/systemd/system/vsound.service ]; then
    cp -v ./vsound.service /lib/systemd/system/
  fi
  depmod -a
  systemctl daemon-reload
  systemctl enable vsound.service

  echo ""
  echo "*Copy Helper Command*"
  cp -v ./aoe_profile.sh /etc/profile.d/
  sync

  echo ""
  echo "*Check MD5 checksums*"
  md5sum -c ./md5

#  if [ ! $? = 0 ]; then
#    echo "ERROR!!!!!!?"
#    exit
#  fi

  . /etc/profile.d/aoe_profile.sh
  modprobe vsound
  modprobe netmap
  systemctl start vsound

  amixer -q sset Digital 100%
  amixer -q sset dreq 16
  amixer -q sset recv 16

  echo ""
  echo "*Audio over Ether module installation is complete*"
  echo ""
  echo "Please set up the playback software manually.　(e.g. mpd)"
  ;;

uninstall)
  systemctl stop vsound
  systemctl disable vsound.service
  rm /lib/systemd/system/vsound.service
  rm /usr/bin/aoe

  modprobe -r vsound
  modprobe -r netmap
  rm /lib/modules/4.19.86-v8/kernel/drivers/xenomai/smpd/netmap.ko
  rm /lib/modules/4.19.86-v8/kernel/drivers/xenomai/smpd/vsound.ko
  cp ./modules.conf.orig /etc/modules-load.d/modules.conf
  rm /etc/profile.d/aoe_profile.sh

  systemctl enable pipe.service

  echo "Uninstall completed."
  echo "Please reboot now."
  ;;
*)
  echo "install | uninstall"
  ;;
esac
